exec("./support_server.cs");

$AdminApp::Version = 1;
$AdminApp::Download = "<linkColor:ffffff><a:forum.blockland.us/index.php?topic=267753.0>";
$AdminApp::FilePath = "config/server/AdminApps/";

////////////////////////////////////////////////////////////////////////////////////////////////////
//Send application info gradually across network to host, before saving app

function serverCmdAdminApp_receiveForm(%client, %varType, %var)
{
	%client.adminApp_lastSubmitBam += 1;
	
	if(($Sim::Time - %client.adminApp_lastSubTimeStart) < 5) //if current time - time function first started >= 5 (resets if >= 5 either way)
	{
		if((%client.adminApp_lastSubmitBam - 26) > 0) //max of 26 server cmds per received form per player every 5 seconds
		{
			echo("\c2>>> Admin App SPAM -> serverCmdAdminApp_receiveForm -> excessive server cmds from player:(" @ %client.name @ "), ID:(" @ %client.bl_id @ "), amount:(" @ %client.adminApp_lastSubmitBam @ ")");

			if(!%client.adminApp_isHost())
			{
				messageAll("","<color:ff0000>>>> Admin App SPAM: <color:ffffff>Player " @ %client.name @ " (BL_ID: " @ %client.bl_id @ ") was spamming server commands while sending an application. Player kicked from server.");
				%client.delete(); //kick player, if not host (included just encase)
			}
			else
				messageAll("","<color:ff0000>>>> Admin App SPAM: <color:ffffff>Player " @ %client.name @ " (BL_ID: " @ %client.bl_id @ ") was spamming server commands while sending an application.");
			
			%client.adminApp_lastSubTimeStart = $Sim::Time;
			%client.adminApp_lastSubmitBam = 0;
			
			return;
		}
	}
	else
	{
		%client.adminApp_lastSubTimeStart = $Sim::Time;
		%client.adminApp_lastSubmitBam = 0;
	}

	if(%client.AdminApp_CLVersion < $AdminApp::Version)
	{
		commandToClient(%client, 'messageBoxOk', "Admin App - Outdated", "You have version\c6" SPC %client.AdminApp_CLVersion SPC "\c0of the Admin Application Mod. You must upgrade to version\c6" SPC $AdminApp::Version SPC "if you wish to apply for admin. You can download the latest version" SPC $AdminApp::Download @ "HERE</a>.");
		return;
	}
	
	if(%varType $= "" || %var $= "")
		return;
	
	//////////////////////////////////////////////////
	
	switch$(%varType)
	{
		case "PrevAdminExp":
			if(%var $= "[Insert a list of servers where you were/are an admin on here.]" || strLen($AdminApp::PrevAdminExp[%client.BL_ID]) > 2040)
			{
				%client.nulifyAdminApp = 1;
				$AdminApp::PrevAdminExp[%client.BL_ID] = "";
				return;
			}

			$AdminApp::PrevAdminExp[%client.BL_ID] = $AdminApp::PrevAdminExp[%client.BL_ID] @ %var;

		case "WhoRec":
			if(%var $= "[Insert list of people who recommend you here. Include Blockland IDs.]" || strLen($AdminApp::WhoRec[%client.BL_ID]) > 2040)
			{
				%client.nulifyAdminApp = 1;
				$AdminApp::WhoRec[%client.BL_ID] = "";
				return;
			}
			$AdminApp::WhoRec[%client.BL_ID] = $AdminApp::WhoRec[%client.BL_ID] @ %var;

		case "WhyAccept":
			if(%var $= "[Insert a paragraph of why you should be accepted here.]" || strLen($AdminApp::WhyAccept[%client.BL_ID]) > 2040)
			{
				%client.nulifyAdminApp = 1;
				$AdminApp::WhyAccept[%client.BL_ID] = "";
				return;
			}
			$AdminApp::WhyAccept[%client.BL_ID] = $AdminApp::WhyAccept[%client.BL_ID] @ %var;

		case "TimeZone":
			if(%var $= "Please Select One:")
			{
				%client.nulifyAdminApp = 1;
				$AdminApp::TimeZone[%client.BL_ID] = "";
				return;
			}
			$AdminApp::TimeZone[%client.BL_ID] = %var;

		case "AdminType":
			if(%var == 2)
				$AdminApp::AdminType[%client.BL_ID] = 2;
			else
				$AdminApp::AdminType[%client.BL_ID] = 1;
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Save an application when the info is fully received from client

function serverCmdAdminApp_finalSubmitForm(%client)
{
	if($Sim::Time - %client.adminApp_lastSubmit < 2.5) //spam check
	{
		%client.adminApp_lastSubmit = $Sim::Time;
		
		messageAll("","<color:ff0000>[Admin App SPAM] <color:ffffff>Player " @ %client.name @ " (BL_ID:" @ %client.bl_id @ ") was spamming server commands while finally submitting their app. Player kicked from server.");
		echo("\c2>>> Admin App SPAM -> serverCmdAdminApp_finalSubmitForm -> excessive server cmds from player:(" @ %client.name @ "), ID:(" @ %client.bl_id @ ")");
		
		if(!%client.adminApp_isHost())
			%client.delete(); //kick player, if not host
		
		$AdminApp::PrevAdminExp[%PlBLID] = "";
		$AdminApp::WhoRec[%PlBLID] = "";
		$AdminApp::WhyAccept[%PlBLID] = "";
		$AdminApp::TimeZone[%PlBLID] = "";
		$AdminApp::AdminType[%PlBLID] = "";
		
		return;
	}
	%client.adminApp_lastSubmit = $Sim::Time;
	
	if(%client.AdminApp_CLVersion < $AdminApp::Version) //version check
	{
		commandToClient(%client, 'messageBoxOk', "Admin App - Outdated", "You have version\c6" SPC %client.AdminApp_CLVersion SPC "\c0of the Admin Application Mod. You must upgrade to version\c6" SPC $AdminApp::Version SPC "if you wish to apply for admin. You can download the latest version" SPC $AdminApp::Download @ "HERE</a>.");
		
		$AdminApp::PrevAdminExp[%PlBLID] = "";
		$AdminApp::WhoRec[%PlBLID] = "";
		$AdminApp::WhyAccept[%PlBLID] = "";
		$AdminApp::TimeZone[%PlBLID] = "";
		$AdminApp::AdminType[%PlBLID] = "";
		
		return;
	}

	if(%client.nulifyAdminApp) //app error check
	{
		%client.nulifyAdminApp = 0;
		commandToClient(%client, 'messageBoxOk', "Admin App - ERROR", "The server found an error in your admin application. Please try again");
		
		$AdminApp::PrevAdminExp[%PlBLID] = "";
		$AdminApp::WhoRec[%PlBLID] = "";
		$AdminApp::WhyAccept[%PlBLID] = "";
		$AdminApp::TimeZone[%PlBLID] = "";
		$AdminApp::AdminType[%PlBLID] = "";
		
		return;
	}
	
	if(!AdminApp_ReApplyCheck(%client,%client.bl_id)) //reapply check
	{
		$AdminApp::PrevAdminExp[%PlBLID] = "";
		$AdminApp::WhoRec[%PlBLID] = "";
		$AdminApp::WhyAccept[%PlBLID] = "";
		$AdminApp::TimeZone[%PlBLID] = "";
		$AdminApp::AdminType[%PlBLID] = "";
		
		return;
	}
	
	//////////////////////////////////////////////////
	
	%PlBLID = %client.bl_id;
	%filePath = $AdminApp::FilePath @ "Pending/" @ %PlBLID @ ".txt";
	%PlName = "\"" @ %client.name @ "\"";
	
	%file = new FileObject();
	%file.openForWrite(%filePath);
	
	%file.writeLine("Admin Application Form for:" SPC %PlName);
	%file.writeLine("Player ID:" SPC %PlBLID);
	%file.writeLine("Previous Admin Experience:" SPC $AdminApp::PrevAdminExp[%PlBLID]);
	%file.writeLine("Who Recommends You:" SPC $AdminApp::WhoRec[%PlBLID]);
	%file.writeLine("Why Should I Accept You:" SPC $AdminApp::WhyAccept[%PlBLID]);
	%file.writeLine("TimeZone/Region:" SPC $AdminApp::TimeZone[%PlBLID]);
	%file.writeLine("Sent:" SPC getDateTime());
	%file.writeLine("Admin Type:" SPC getWord(" Admin Super-Admin",$AdminApp::AdminType[%PlBLID]));
	
	%file.close();
	%file.delete();
	
	commandtoClient(%client, 'messageboxOk', "Admin App - Submitted", "<font:Impact:18>Your admin application has been <color:00CC00>successfully submitted <color:000000>to the server host! Please allow some time for it to be reviewed.");
	echo("\c4>>> Admin App Note -> serverCmdAdminApp_finalSubmitForm -> New application received from player:(" @ %client.name @ "), ID:(" @ %client.bl_id @ ")");
	
	adminApp_notifyHost(%PlBLID);

	$AdminApp::PrevAdminExp[%PlBLID] = "";
	$AdminApp::WhoRec[%PlBLID] = "";
	$AdminApp::WhyAccept[%PlBLID] = "";
	$AdminApp::TimeZone[%PlBLID] = "";
	$AdminApp::AdminType[%PlBLID] = "";
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Response by host to a pending application

function serverCmdAdminApp_Review(%client, %id, %status, %reason)
{
	//prevent duplicate files in other folders

	//Status -1 = blacklist
	//Status 0 = deny
	//Status 1 = admin
	//Status 2 = superadmin

	if(!%client.adminApp_isHost())
		return;
	
	if($Sim::Time - %client.adminApp_lastSubmit < 2.5) //host-only spam check (to protect server)
	{
		%client.adminApp_lastSubmit = $Sim::Time;
		
		commandToClient(%client,'messageBoxOk', "Admin App - SPAM","<color:FF0000>Excessive commands <color:000000> sent to server while responding to app; please wait 2.5 seconds.");
		echo("\c2>>> Admin App SPAM -> serverCmdAdminApp_Review -> excessive server cmds from player:(" @ %client.name @ "), ID:(" @ %client.bl_id @ ")");
		
		return;
	}
	%client.adminApp_lastSubmit = $Sim::Time;
	
	//////////////////////////////////////////////////
	
	if(!isFile(%filePath = $AdminApp::FilePath @ "Pending/" @ %id @ ".txt"))
	{
		commandToClient(%client, 'messageBoxOk', "Admin App - ERROR","Invalid App File:" @ %filePath);
		commandToClient(%client,'AdminApp_RelayRefreshAppList');
		
		return;
	}
	
	%target = findClientByBL_ID(%id);
	
	if(%id == %client.bl_id || %id == 999999 || %id == 888888 || AdminApp_hasItemOnList($Pref::Server::AutoSuperAdminList, %id) || AdminApp_hasItemOnList($Pref::Server::AutoAdminList, %id) || %target.isAdmin) // || AdminApp_hasItemOnList($Pref::Server::AdminAppBlackList, %id))
	{
		if(%id == %client.bl_id)
			commandToClient(%client, 'messageBoxOk', "Admin App - ERROR","Applicant's BL_ID (" @ %id @ ") == Host's BL_ID (" @ %client.bl_id @ "). Application response failed; file has been removed.");
		else if(%id == 999999 || %id == 888888)
			commandToClient(%client, 'messageBoxOk', "Admin App - ERROR","Applicant's BL_ID (" @ %id @ ") is invalid (ID = 888888 or 999999). Application response failed; file has been removed.");
		else if(AdminApp_hasItemOnList($Pref::Server::AutoSuperAdminList, %id))
			commandToClient(%client, 'messageBoxOk', "Admin App - ERROR","Applicant is already on Auto Super Admin list. Application response failed; file has been removed.");
		else if(AdminApp_hasItemOnList($Pref::Server::AutoAdminList, %id))
			commandToClient(%client, 'messageBoxOk', "Admin App - ERROR","Applicant is already on Auto Admin list. Application response failed; file has been removed.");
		else if(%target.isAdmin)
			commandToClient(%client, 'messageBoxOk', "Admin App - ERROR","Applicant already has an administrative position. Application response failed; file has been removed.");

		fileDelete(%filePath);
		commandToClient(%client,'AdminApp_RelayRefreshAppList');
		
		return;
	}

	//////////////////////////////////////////////////
	//Blacklisted response
	
	if(%status == -1)
	{
		if(!AdminApp_MoveFile(%client,"Pending/","Blacklisted/",%id))
			return;
		
		%file = new fileObject();
		%filePathB = $AdminApp::FilePath @ "Blacklisted/" @ %id @ ".txt";
		%file.openForRead(%filePathB);
	
		%c = 0; //otherwise if not defined, causes issue with writing first line of file, below
		while(!%file.isEOF())
		{
			%line = %file.readLine();
			
			if(getWords(%line,0,1) !$= "Blacklist Reason:") //just encase, overwrites the current blacklist reason - if present
				%lineArr[%c] = %line;
				
			%c++;
		}

		%file.openForWrite(%filePathB);
		
		for(%d=0; %d<%c; %d++)
			%file.writeLine(%lineArr[%d]);
			
		%file.writeLine("Blacklist Reason: " @ %reason);
	
		%file.close();
		%file.delete();
		
		if(%reason !$= "") //reason should be included, this is just encase
			%text = "<font:Impact:18>Your application has been <color:FF0000>blacklisted<color:000000>!<br><br>Reason:" SPC %reason;
		else
			%text = "<font:Impact:18>Your application has been <color:FF0000>blacklisted<color:000000>!";
				
		if(isObject(%target))
		{
			commandToClient(%target, 'messageboxOk', "Admin App - Blacklisted", %text);
			commandToClient(%client, 'messageBoxOk', "Admin App - Success","Application has been <color:00CC00>successfully blacklisted<color:000000>; applicant notified.");
		}
		else
		{
			commandToClient(%client, 'messageBoxOk', "Admin App - Success","Application has been <color:00CC00>successfully blacklisted<color:000000>; applicant will be notified the next time they join the server.");
			AdminApp_AppDelayNotify(%id,"Admin App - Blacklisted",%text);
		}
	}

	//////////////////////////////////////////////////
	
	else if(%status > 0)
	{
		$Pref::Server::AutoAdminList = AdminApp_removeItemFromList($Pref::Server::AutoAdminList, %id);
		$Pref::Server::AutoSuperAdminList = AdminApp_removeItemFromList($Pref::Server::AutoSuperAdminList, %id);

		if(%status == 1)
			$Pref::Server::AutoAdminList = AdminApp_addItemToList($Pref::Server::AutoAdminList, %id);
		else if(%status == 2)
			$Pref::Server::AutoSuperAdminList = AdminApp_addItemToList($Pref::Server::AutoSuperAdminList, %id);
			
		export("$Pref::Server::*", "config/server/prefs.cs");		

		if(isObject(%target))
		{
			%target.isAdmin = 1;

			//////////////////////////////////////////////////
			//Admin response
	
			if(%status == 1)
			{
				%text = "<font:Impact:18>Your admin application has been <color:00CC00>accepted<color:000000>! You\'ve been give the position of <color:00CC00>Admin<color:000000>.";

				%target.sendPlayerlistUpdate();
				commandToClient(%target, 'setAdminLevel', 1);

				messageAll('MsgAdminForce', '\c2%1 has become Admin (Auto, Application)', %target.name);
				commandToClient(%client,'messageBoxOk',"Admin App - Success","Application has been <color:00CC00>accepted<color:000000>; applicant has become <color:00CC00>Admin<color:000000> and has been notified.");
			}

			//////////////////////////////////////////////////
			//Super-Admin response
	
			else if(%status == 2)
			{
				%text = "<font:Impact:18>Your admin application has been <color:00CC00>accepted<color:000000>! You\'ve been give the position of <color:00CC00>Super Admin<color:000000>.";
				
				%target.isSuperAdmin = 1;
				%target.sendPlayerlistUpdate();
				commandToClient(%target, 'setAdminLevel', 2);

				messageAll('MsgAdminForce', '\c2%1 has become Super Admin (Auto, Application)', %target.name);
				commandToClient(%client,'messageBoxOk',"Admin App - Success","Application has been <color:00CC00>accepted<color:000000>; applicant has become <color:00CC00>Super Admin<color:000000> and has been notified.");
			}
		
			commandToClient(%target, 'messageBoxOk', "Admin App - Accepted!", %text);
		}
		else
		{
			if(%status == 1)
			{
				messageAll('MsgAdminForce', '\c2%1 has become Admin (Auto, Application)', %id);
				commandToClient(%client,'messageBoxOk',"Admin App - Success","Application has been <color:00CC00>accepted<color:000000>; applicant has become <color:00CC00>Admin <color:000000>and will be notified the next time they join the server.");
				AdminApp_AppDelayNotify(%id,"Admin App - Accepted!","Your admin application has been <color:00CC00>accepted<color:000000> - you have been given the position of <color:00CC00>Admin<color:000000>.");
			}
			else if(%status == 2)
			{
				messageAll('MsgAdminForce', '\c2%1 has become Super Admin (Auto, Application)', %id);
				commandToClient(%client,'messageBoxOk',"Admin App - Success","Application has been <color:00CC00>accepted<color:000000>; applicant has become <color:00CC00>Super Admin <color:000000>and will be notified the next time they join the server.");
				AdminApp_AppDelayNotify(%id,"Admin App - Accepted!","Your admin application has been <color:00CC00>accepted<color:000000> - you have been given the position of <color:00CC00>Super Admin<color:000000>.");
			}
		}
		
		fileDelete($AdminApp::FilePath @ "Pending/" @ %id @ ".txt");
		commandToClient(%client,'AdminApp_RelayRefreshAppList');
	}
	
	//////////////////////////////////////////////////
	//Denied response

	else if(%status == 0)
	{
		if(!AdminApp_MoveFile(%client,"Pending/","Denied/",%id))
			return;
		
		if(%reason !$= "") //reason should be included, this is just encase
			%text = "<font:Impact:18>Your application has been <color:FFFF00>denied<color:000000>!<br><br>Reason:" SPC %reason;
		else
			%text = "<font:Impact:18>Your application has been<br><color:FFFF00>denied<color:000000>!";
			
		if(isObject(%target))
		{
			commandToClient(%target, 'messageboxOk', "Admin App - Denied", %text);
			commandToClient(%client, 'messageBoxOk', "Admin App - Success","Application has been <color:00CC00>successfully denied<color:000000>; applicant notified.");
		}
		else
		{
			commandToClient(%client, 'messageBoxOk', "Admin App - Success","Application has been <color:00CC00>successfully denied<color:000000>; applicant will be notified the next time they join the server.");
			AdminApp_AppDelayNotify(%id,"Admin App - Denied",%text);
		}
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Move a player's application from Denied to Pending

function serverCmdAdminApp_unDeny(%client, %id)
{
	if($Sim::Time - %client.adminApp_lastSubmit < 2.5) //host-only spam check (to protect server)
	{
		%client.adminApp_lastSubmit = $Sim::Time;
		
		commandToClient(%client,'messageBoxOk', "Admin App - SPAM","<color:FF0000>Excessive commands <color:000000>sent to server while attempting to unDeny app; please wait 2.5 seconds.");
		echo("\c2>>> Admin App SPAM -> serverCmdAdminApp_unDeny -> excessive server cmds from player:(" @ %client.name @ "), ID:(" @ %client.bl_id @ ")");
		
		return;
	}
	%client.adminApp_lastSubmit = $Sim::Time;
	
	if(!%client.adminApp_isHost())
		return;
	
	if(!AdminApp_MoveFile(%client,"Denied/","Pending/",%id))
		return;
	
	%target = findClientByBL_ID(%id);

	if(isObject(%target))
	{
		commandToClient(%client, 'messageBoxOk', "Admin App - Success", "Application has been <color:00CC00>successfully moved <color:000000>to the Pending category; applicant notified.");
		commandToClient(%target, 'messageBoxOk', "Admin App - UnDenied", "<font:Impact:18>The server host has decided to <color:00CC00>re-review <color:000000>your admin application.");
	}
	else
	{
		commandToClient(%client, 'messageBoxOk', "Admin App - Success", "Application has been <color:00CC00>successfully moved <color:000000>to the Pending category; applicant will be notified the next time they join the server.");
		AdminApp_AppDelayNotify(%id,"Admin App - Denied","<font:Impact:18>The server host has decided to <color:00CC00>re-review <color:000000>your admin application.");
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Remove a player's application from being Blacklisted

function serverCmdAdminApp_unBlacklist(%client, %id)
{
	//reference app in Blacklist category
	//make sure id exists / app by id is in Blacklist category
	//Move to Pending category if unblacklisted
	
	if($Sim::Time - %client.adminApp_lastSubmit < 2.5) //host-only spam check (to protect server)
	{
		%client.adminApp_lastSubmit = $Sim::Time;
		
		commandToClient(%client,'messageBoxOk', "Admin App - SPAM","<color:FF0000>Excessive commands <color:000000>sent to server while attempting to unBlacklist app; please wait 2.5 seconds.");
		echo("\c2>>> Admin App SPAM -> serverCmdAdminApp_unBlacklist -> excessive server cmds from player:(" @ %client.name @ "), ID:(" @ %client.bl_id @ ")");
		
		return;
	}
	%client.adminApp_lastSubmit = $Sim::Time;
	
	if(!%client.adminApp_isHost())
		return;
	
	//////////////////////////////////////////////////
	
	if(!AdminApp_MoveFile(%client,"Blacklisted/","Pending/",%id))
		return;
	
	%target = findClientByBL_ID(%id);

	if(isObject(%target))
	{
		commandToClient(%client, 'messageBoxOk', "Admin App - Success", "Application has been <color:00CC00>successfully unBlacklisted<color:000000>; applicant notified");
		commandToClient(%target, 'messageBoxOk', "Admin App - UnBlacklisted", "<font:Impact:18>Your application has been <color:00CC00>unBlacklisted<color:000000>.");
	}
	else
	{
		commandToClient(%client, 'messageBoxOk', "Admin App - Success", "Application has been <color:00CC00>successfully unBlacklisted<color:000000>; applicant will be notified the next time they join the server.");
		AdminApp_AppDelayNotify(%id,"Admin App - Denied","<font:Impact:18>Your application has been <color:00CC00>unBlacklisted<color:000000>.");
	}
	
	%file = new fileObject();
	%filePath = $AdminApp::FilePath @ "Pending/" @ %id @ ".txt";
	%file.openForRead(%filePath);

	%c = 0; //otherwise if not defined, causes issue with writing first line of file, below
	while(!%file.isEOF())
	{
		%line = %file.readLine();
		
		if(getWords(%line,0,1) !$= "Blacklist Reason:") //just encase, overwrites the current blacklist reason - if present
			%lineArr[%c] = %line;
			
		%c++;
	}

	%file.openForWrite(%filePath);
	
	for(%d=0; %d<(%c-1); %d++)
		%file.writeLine(%lineArr[%d]);

	%file.close();
	%file.delete();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Determine which GUI to open for server instance for player (if host or not)

function serverCmdAdminApp_DetermineGUI(%client)
{
	%reApplyLimit = getWord($Pref::Server::ReApplyLimit,0);
	
	if(%client.AdminApp_CLVersion < $AdminApp::Version)
	{
		commandToClient(%client, 'messageBoxOk', "Admin App - Outdated", "You have version\c6" SPC %client.AdminApp_CLVersion SPC "\c0of the Admin Application Mod. You must upgrade to version\c6" SPC $AdminApp::Version SPC "if you wish to apply for admin. You can download the latest version" SPC $AdminApp::Download @ "HERE</a>.");
		return;
	}
	
	if(%client.adminApp_isHost())
	{
		commandToClient(%client,'AdminApp_SetGUI',"Host",%reApplyLimit);
		echo("\c4>>> " @ %client.name SPC "requested Admin App GUI; determined as host of server");
	}

	else
	{
		commandToClient(%client,'AdminApp_SetGUI',"NotHost","");
		echo("\c4>>> " @ %client.name SPC "requested Admin App GUI");
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Update server reapply limit variable, when changed by host

function serverCmdAdminApp_UpdatePrefs(%cl,%strPref)
{
	if(!%cl.adminApp_isHost())
		return;
	
	if($Pref::Server::ReApplyLimit !$= %strPref)
	{
		$Pref::Server::ReApplyLimit = %strPref;
		export("$Pref::Server::*", "config/server/prefs.cs");
		
		messageAll("","\c6>>> \c0The server has updated the limit for resending applications to:\c6" SPC getWords(%strPref,1,getWordCount(%strPref)));
		commandToClient(%cl, 'messageboxOK', "Admin App - Pref Updated", "Application reapply limits have been updated <color:00CC00>successfully<color:000000>!");
	
		echo("\c4>>> Admin App Note -> serverCmdAdminApp_UpdatePrefs -> reapply limit set to: " @ getWords(%strPref,1,getWordCount(%strPref)));
	}
}	

////////////////////////////////////////////////////////////////////////////////////////////////////
//Restriction check for reapplication

function AdminApp_ReApplyCheck(%client,%id)
{
	//Current date
	%dateB = getWord(getDateTime(),0);
	%dateB = strReplace(%dateB,"/"," ");
	%timeB = getWord(getDateTime(),1);
	%timeB = strReplace(%timeB,":"," ");
	
	//Take leap years into account
	%leapYear = getWord(strReplace(%dateB,"/"," "),2);
	if((%leapYear / 4) == mFloor(%leapYear / 4))
		%feb = 29;
	else
		%feb = 28;
	
	%daysStr = 31 SPC %feb SPC "31 30 31 30 31 31 30 31 30 31";

	//////////////////////////////////////////////////
	
	//check blacklist first, return false if so w/ msg of reason blacklisted
	//check if pending or already admin / super admin, return false if so w/ msg that reapplying isn't necessary
	//check denied folder last
	//if file found in denied, save var %appFound=1 for last reapply limit option
	
	%filePathDenied = $AdminApp::FilePath @ "Denied/" @ %id @ ".txt";
	%filePathBlList = $AdminApp::FilePath @ "Blacklisted/" @ %id @ ".txt";
	%filePathPending = $AdminApp::FilePath @ "Pending/" @ %id @ ".txt";
	
	if(isFile(filePathBlList))
	{
		%file = new fileObject();
		%file.openForRead(%filePathBlList);
		
		while(!%file.isEOF())
		{
			%line = %file.readLine();

			if(getWords(%line,0,1) $= "Blacklist Reason:")
			{
				%reason = getWords(%line,2,getWordCount(%line));
				break;
			}
		}
		
		%file.close();
		%file.delete();
		
		if(%reason !$= "")
			commandToClient(%client, 'messageBoxOk', "Admin App - Blacklisted", "<font:Impact:18>Your application has been <color:FF0000>blacklisted<color:000000>!<br><br>Reason:" SPC %reason);
		else
			commandToClient(%client, 'messageBoxOk', "Admin App - Blacklisted", "<font:Impact:18>Your application has been <color:FF0000>blacklisted<color:000000>!");
		
		return false;
	}
	else if(isFile(%filePathPending))
	{
		commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You have already submitted a pending application - please wait for it to be reviewed first.");
		return false;
	}
	else if(%client.isAdmin) //also should work for super admins and on dedicated servers (esp. for host)
	{
		commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You have already been given an administrative position.");
		return false;
	}
	else if(isFile(%filePathDenied))
	{
		%file = new fileObject();
		%file.openForRead(%filePathDenied);

		while(!%file.isEOF())
		{
			%line = %file.readLine();

			if(getWord(%line,0) $= "Sent:")
			{
				//Previous date
				%dateA = getWord(%line,1);
				%dateA = strReplace(%dateA,"/"," ");
				%timeA = getWord(%line,2);
				%timeA = strReplace(%timeA,":"," ");
				
				break;
			}
		}
		
		%file.close();
		%file.delete();
		
		%appFound = 1;
	}
	else
		return true; //if no file, no restriction check is necessary since player hasn't applied prior

	%method = getWord($Pref::Server::ReApplyLimit,0);
	
	if(%method == 0) //If No Limit option selected for reapplying, and player has a denied app, automatically allow reapplication
	{
		fileDelete(%filePathDenied);
		return true;
	}

	//////////////////////////////////////////////////
	//Subtract total days to find remainder
	
	%yearA = getWord(%dateA,2);
	%yearB = getWord(%dateB,2);
	%monthA = getWord(%dateA,0);
	%monthB = getWord(%dateB,0);
	%dayA = getWord(%dateA,1);
	%dayB = getWord(%dateB,1);
	
	%daysInitial = mFloor((%yearB - %yearA) * 365.25);
	%dayCountA = %dayA;
	%dayCountB = %daysInitial + %dayB;
	
	for(%c=0; %c<%monthA-1; %c++)
		%dayCountA += getWord(%daysStr,%c);
		
	for(%c=0; %c<%monthB-1; %c++)
		%dayCountB += getWord(%daysStr,%c);
		
	%daysFinal = %dayCountB - %dayCountA;

	//////////////////////////////////////////////////
	//Check if remainder of days / time passes reapply limit restriction set by host
	
	switch(%method)
	{
		case 1:
			if((%dayB > (%dayA+1)) || %monthB > %monthA || %yearB > %yearA)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else if(%dayB > %dayA)
			{
				if(((getWord(%timeB,0)+24) - getWord(%timeA,0) > 12))
				{
					fileDelete(%filePathDenied);
					return true;
				}
				else
				{
					commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>12 hours <color:000000>before resubmitted your application.");
					return false;
				}
			}
			else if((getWord(%timeB,0) - getWord(%timeA,0) > 12))
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>12 hours <color:000000>before resubmitted your application.");
				return false;
			}
		case 2:
			if(%daysFinal >= 1)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>1 day <color:000000>before resubmitted your application.");
				return false;
			}
		case 3:
			if(%daysFinal >= 2)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>2 days <color:000000>before resubmitted your application.");
				return false;
			}
		case 4:
			if(%daysFinal >= 3)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>3 days <color:000000>before resubmitted your application.");
				return false;
			}
		case 5:
			if(%daysFinal >= 4)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>4 days <color:000000>before resubmitted your application.");
				return false;
			}
		case 6:
			if(%daysFinal >= 5)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>5 days <color:000000>before resubmitted your application.");
				return false;
			}
		case 7:
			if(%daysFinal >= 6)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>6 days <color:000000>before resubmitted your application.");
				return false;
			}
		case 8:
			if(%daysFinal >= 7)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>1 week <color:000000>before resubmitted your application.");
				return false;
			}
		case 9:
			if(%daysFinal >= 14)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>2 weeks <color:000000>before resubmitted your application.");
				return false;
			}
		case 10:
			if(%daysFinal >= 21)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>3 weeks <color:000000>before resubmitted your application.");
				return false;
			}
		case 11:
			if(%daysFinal >= 28)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>1 month <color:000000>before resubmitted your application.");
				return false;
			}
		case 12:
			if(%daysFinal >= 35)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>5 weeks <color:000000>before resubmitted your application.");
				return false;
			}
		case 13:
			if(%daysFinal >= 42)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>6 weeks <color:000000>before resubmitted your application.");
				return false;
			}
		case 14:
			if(%daysFinal >= 49)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>7 weeks <color:000000>before resubmitted your application.");
				return false;
			}
		case 15:
			if(%daysFinal >= 56)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>2 months <color:000000>before resubmitted your application.");
				return false;
			}
		case 16:
			if(%daysFinal >= 84)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>3 months <color:000000>before resubmitted your application.");
				return false;
			}
		case 17:
			if(%daysFinal >= 112)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>4 months <color:000000>before resubmitted your application.");
				return false;
			}
		case 18:
			if(%daysFinal >= 140)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>5 months <color:000000>before resubmitted your application.");
				return false;
			}
		case 19:
			if(%daysFinal >= 168)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You must wait at least <color:ff0000>6 months <color:000000>before resubmitted your application.");
				return false;
			}
		case 20:
			if(!%appFound)
			{
				fileDelete(%filePathDenied);
				return true;
			}
			else
			{
				commandToClient(%client, 'messageBoxOk', "Admin App - ReApply Failed", "You are only allowed to submit <color:ff0000>one <color:000000>application.");
				return false;
			}
		default:
			echo("\c2>>> Admin App ERROR -> AdminApp_ReApplyCheck -> Switch at line 946 reverted to default case due to unknown issue.");
			return false;
		
	}	
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Save message to notify player later (on server join), if not present on server at the time

function AdminApp_AppDelayNotify(%id,%title,%msg)
{
	%filePath = $AdminApp::FilePath @ %id @ "_message.txt";

	%file = new fileObject();
	%file.openForWrite(%filePath);

	%file.writeLine(%title);
	%file.writeLine(%msg);
	
	%file.close();
	%file.delete();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Move an application to a new category, after a response is made by the host (meant only for reviewform function)

function AdminApp_MoveFile(%client,%from,%to,%id)
{
	%filePathA = $AdminApp::FilePath @ %from @ %id @ ".txt";
	
	if(isFile(%filePathA))
	{
		%filePathB = $AdminApp::FilePath @ %to @ %id @ ".txt";
		
		fileCopy(%filePathA,%filePathB);
		fileDelete(%filePathA);
		
		%file = new fileObject();
		%file.openForRead(%filePathB); //so that the new file registers (for app list)
		
		%file.close();
		%file.delete();
		
		commandToClient(%client,'AdminApp_RelayRefreshAppList'); //auto refresh host's app list in review gui [Host-Only]

		return true;
	}
	else
	{
		commandToClient(%client, 'messageBoxOk', "Admin App - ERROR","Invalid File: " @ %filePathA);
		commandToClient(%client,'AdminApp_RelayRefreshAppList'); //auto refresh host's app list in review gui [Host-Only]
		
		return false;
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Notify server host of newly received application

function AdminApp_NotifyHost(%id)
{
	for(%c = 0; %c < clientGroup.getCount(); %c++)
	{
		%tempCl = clientGroup.getObject(%c);
		
		if(%tempCl.adminApp_isHost())
		{
			%hostCl = %tempCl;
			%hostFound = 1;

			break;
		}
	}

	%client = findClientByBL_ID(%id);
	
	if(!%hostFound)
	{
		if(isObject(%client))
			%msg = "<sPush>You have a new admin-request application from <font:verdana bold:14>" @ %client.name SPC "(BL_ID:" SPC %id @ ") <sPop>waiting for review.";
		else //If for some weird reason the client no longer exists.
			%msg = "<sPush>You have a new admin-request application from BL_ID <font:verdana bold:14>" @ %id @ "<sPop> waiting for review.";
		
		AdminApp_AppDelayNotify(getNumKeyID(),"Admin App - New App Notification",%msg);
	}
	else
	{
		if(isObject(%client))
			commandToClient(%hostCl,'messageboxOK',"Admin App - New App Notification","<sPush>You have a new admin-request application from <font:verdana bold:14>" @ %client.name SPC "(BL_ID:" SPC %id @ ") <sPop>waiting for review.");
		else //If for some weird reason the client no longer exists.
			commandToClient(%hostCl,'messageboxOK',"Admin App - New App Notification","<sPush>You have a new admin-request application from BL_ID <font:verdana bold:14>" @ %id @ "<sPop> waiting for review.");
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////

package AdminApp_Server
{
	//////////////////////////////////////////////////
	//Load client's current version of the add-on
	
	function gameConnection::onConnectRequest(%client, %a, %lan_name, %net_name, %clan_prefix, %clan_suffix, %b, %g, %h, %i, %j)
	{
		if(getField(%j, 0) $= "AdminApp")
			%client.AdminApp_CLVersion = getField(%j, 1); //onConnectRequest is exec prior to autoAdminCheck

		parent::onConnectRequest(%client, %a, %lan_name, %net_name, %clan_prefix, %clan_suffix, %b, %g, %h, %i, %j);
	}

	//////////////////////////////////////////////////
	//Notify player of add-on version sync-check, and of any unreceived messages on server join; other misc. stuff
	
	function gameConnection::autoAdminCheck(%client)
	{
		%parent = parent::autoAdminCheck(%client);
		
		commandToClient(%client, 'AdminApp_hasMod', 1);
		
		if(%client.AdminApp_CLVersion != 0)
		{
			if(%client.AdminApp_CLVersion < $AdminApp::Version)
				messageClient(%client, '', "\c6>>> \c0This server is running version \c6(" @ $AdminApp::Version @ ") \c0of the \c6Admin Applications Add-On\c0, you have version \c6(" @ %client.AdminApp_CLVersion @ ") \c0. If you wish to apply for admin; please upgrade " @ $AdminApp::Download @ "HERE</a>.");
			else if(%client.AdminApp_CLVersion > $AdminApp::Version)
			{
				messageClient(%client, '', "\c6>>> \c0You have version \c6(" @ %client.AdminApp_CLVersion @ ") \c0of the \c6Admin Applications Add-On\c0, but the server is running version \c6(" @ $AdminApp::Version @ ")\c0. Please tell the host to upgrade!");
				echo("\c4>>> Admin App Note -> autoAdminCheck(Packaged) -> A player joined with version (" @ %client.AdminApp_CLVersion @ ") of Admin Apps; you might need to upgrade.");
			}
			else
				messageClient(%client, '', "\c6>>> \c0This server is running version \c6(" @ $AdminApp::Version @ ") \c0of the " @ $AdminApp::Download @ "Admin Applications Add-On</a>; make sure to fill out an application if you wish to apply for an admin position.");
		}
		else
			messageClient(%client, '', "\c6>>> \c0This server is running version \c6(" @ $AdminApp::Version @ ") \c0of the " @ $AdminApp::Download @ "Admin Applications Add-On</a>, which is required for requesting a server administration position.");
		
		if(isFile(%filePath = $AdminApp::FilePath @ %client.BL_ID @ "_message.txt"))
		{			
			%file = new fileObject();
			%file.openForRead(%filePath);
			
			%title = %file.readLine();
			%msg = %file.readLine();

			%file.close();
			%file.delete();

			commandToClient(%client,'messageBoxOk',%title,%msg);
			fileDelete(%filePath);
		}

		return %parent;
	}
	
	//////////////////////////////////////////////////
	//Notify player to use Admin App Add-On if they ask for admin
	
	function serverCmdmessagesent(%client,%text)
	{
		if(%client.adminApp_isHost() || %client.isAdmin)
		{
			Parent::serverCmdmessagesent(%client,%text);
			return;
		}
		
		%specChar = ".,:;-_+`\"'?*=><[]{}()%^~@#$%\\/|";
		
		for(%c=0; %c<strLen(%text); %c++)
		{
			%replace = false;
			
			for(%d=0; %d<strLen(%specChar); %d++)
			{
				if(getSubStr(%text,%c,1) $= getSubStr(%specChar,%d,1))
					%replace = true;
			}
			if(%replace)
				%tempText = %tempText @ " ";
			else
				%tempText = %tempText @ getSubStr(%text,%c,1);
		}
		
		//////////////////////////////////////////////////
		
		for(%c=0; %c<getWordCount(%tempText); %c++)
		{
			if(getWord(%tempText,%c) $= "admin" || getWord(%tempText,%c) $= "administrator" || getWord(%tempText,%c) $= "superadmin" || getWord(%tempText,%c) $= "super-admin")
				%textAdmin = true;
			else if(getWord(%tempText,%c) $= "can" || getWord(%tempText,%c) $= "may" || getWord(%tempText,%c) $= "will" || getWord(%tempText,%c) $= "I" || getWord(%tempText,%c) $= "me")
				%textReq = true;
			else if(getWord(%tempText,%c) $= "has" || getWord(%tempText,%c) $= "have" || getWord(%tempText,%c) $= "be" || getWord(%tempText,%c) $= "give" || getWord(%tempText,%c) $= "mind" || getWord(%tempText,%c) $= "make" || getWord(%tempText,%c) $= "require")
				%textVerb = true;
			else if(getWord(%tempText,%c) $= "please" || getWord(%tempText,%c) $= "pls" || getWord(%tempText,%c) $= "me") //second case of "me" used
				%textAux = true;
		}
		
		if(%textAdmin && ((%textReq && %textVerb) || %textAux))
		{
			messageClient(%client,'',"<color:ffffff>>>> <color:ff0000>If you would like an admin position, use the " @ $AdminApp::Download @ " Admin Applications Add-On</a> and submit an application form.");
			Parent::serverCmdmessagesent(%client,"");
		}
		else
			Parent::serverCmdmessagesent(%client,%text);
	}
};
activatePackage(AdminApp_Server);